<?php

	include("globals.inc");
	include("db.inc");

	session_start();
	if ($_SESSION['user'] == "") {
		header("Location: login.php");
		die;
	}

	# Load up vars
	$name = $_POST['name'];
	$description = $_POST['description'];
	$species = $_POST['species'];
	if ($_POST['otherspecies'] != "") $species = $_POST['otherspecies'];
	$breed = $_POST['breed'];
	if ($_POST['otherbreed'] != "") $breed = $_POST['otherbreed'];
	$age = $_POST['age'];
	$gender = $_POST['gender'];
	$size = $_POST['size'];
	$flags = $_POST['flags'];

	# Validate we have mandatory fields completed
	if ($name == "") {
		echo "<html><body><p>" . $i18n['Name_cannot_be_empty'] . "</p></body></html>";
		die;
	}

	if ($description == "") {
		echo "<html><body><p>" . $i18n['Description_cannot_be_empty'] . "</p></body></html>";
		die;
	}

	# Sanitise fields for SQL injection
	$name = str_replace("'", "_", $name);
	$description = str_replace("'", "_", $description);
	$species = str_replace("'", "_", $species);
	$breed = str_replace("'", "_", $breed);
	$age = str_replace("'", "_", $age);
	$gender = str_replace("'", "_", $gender);
	$size = str_replace("'", "_", $size);
	$flags = str_replace("'", "_", $flags);

	# Sort out uploaded picture
	$picname = "";
	$haspic = TRUE;
	if ($_FILES['picture']['size'] == 0) {
		// No picture
		$haspic = FALSE;
	}
	else {
		$haspic = TRUE;
		$picname = $_FILES['picture']['name'];
		
		# Make the target path to move to
		$targetpath = $homes . "/" . $_SESSION['user'] . "/" . $picname;
		
		# Move the pic to this shelter's home dir
		move_uploaded_file($_FILES['picture']['tmp_name'], $targetpath);

		# Use Imagemagick to rescale it
		shell_exec("$convert_binary $targetpath -resize 300x200 $targetpath");

		# Generate a thumbnail
		shell_exec("$convert_binary $targetpath -resize 100x75 $targetpath.thm.jpg");
	}

	# Create the database entry for the animal
	addAnimal($name, $description, $species, $breed, $age, $gender, $size, $flags, $_SESSION['user'], $haspic, $picname);

	# Go back to the main list to show the new animal
	header("Location: listanimals.php");
	
?>
