<?php

include "globals.inc";
include "i18n.inc";


	# The MySQL API for PHP is so separate from other APIs that I now
	# see why people don't write database-portable PHP stuff - you can't!

	# Anyway, I've made sure everything related to db access and
	# data is in this file so if you want a Postgre version, everything
	# is in here (of course, it's a whopper and will take you ages).

	$username="root";
	$password="";
	$host="localhost";
	$database="petlocator";

	function runQuery($sql) {
		global $username, $password, $host, $database;
		mysql_connect($host, $username, $password);
		@mysql_select_db($database) or die("No petlocator database.") or die("Failed to connect to database.");
		$result = mysql_query($sql);
		mysql_close();
		return $result;
	}

	function executeQuery($sql) {
		global $username, $password, $host, $database;
		mysql_connect($host, $username, $password) or die("Failed to connect to database.");
		@mysql_select_db($database) or die("No petlocator database.");
		mysql_query($sql);
		mysql_close();
	}

	# Returns the species used in the database as HTML Option tags
	function getSpeciesAsOptions() {
		$result = runQuery("SELECT DISTINCT SPECIES FROM ANIMAL ORDER BY SPECIES");
		$num=mysql_numrows($result);
		$html = "";
		for ($i=0; $i < $num; $i++) {
			$html = $html . "<OPTION>" . mysql_result($result, $i, "SPECIES") . "</OPTION>";
		}
		return $html;
	}
	
	# Returns the breeds used in the database as HTML Option tags
	function getBreedAsOptions() {
		$result = runQuery("SELECT DISTINCT BREED FROM ANIMAL ORDER BY BREED");
		$num=mysql_numrows($result);
		$html = "";
		for ($i=0; $i < $num; $i++) {
			$html = $html . "<OPTION>" . mysql_result($result, $i, "BREED") . "</OPTION>";
		}
		return $html;
	}

	# Runs the search and returns the results as an HTML string. Startpage can be given
	# which shows 10 results starting at page-1*10
	function searchResults($species, $breed, $age, $gender, $size, $area, $startpage) {

		global $i18n;
		global $advertising;

		# Construct WHERE clause from details given
		$where = "";
		$showcl = "";
		if ($species != $i18n['Any']) {
			if ($where != "") $where = $where . " AND ";
			$where = $where . "ANIMAL.SPECIES = '" . $species . "'";
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Species:'] . " " . $species;
		}
		if ($breed != $i18n['Any']) {
			if ($where != "") $where = $where . " AND ";
			$where = $where . "ANIMAL.BREED = '" . $breed . "'";
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Breed:'] . " " . $breed;
		}
		if ($age != -1) {
			if ($where != "") $where = $where . " AND ";
			$where = $where . "ANIMAL.AGE = " . $age;
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Age:'] . " " . showAge($age);
		}
		if ($gender != -1) {
			if ($where != "") $where = $where . " AND ";
			$where = $where . "ANIMAL.SEX = " . $gender;
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Gender:'] . " " . showGender($gender);
		}
		if ($size != -1) {
			if ($where != "") $where = $where . " AND ";
			$where = $where . "ANIMAL.SIZE = " . $size;
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Size:'] . " " . showSize($size);
		}
		if ($area != "") {
			if ($where != "") $where = $where . " AND ";
			# If more than one word was given, just use the first
			if (strpos($area, " "))
				$area = substr($area, 0, strpos($area, " "));
			$where = $where . "SHELTER.RELATEDAREAS LIKE '%" . $area . "%'";
			if ($showcl != "") $showcl = $showcl . ", ";
			$showcl = $showcl . $i18n['Area:'] . " " . $area;
		}

		# Display the clause
		if ($showcl == "") $showcl = $i18n['All'];
		$html = "<p><b>" . $i18n['Query:'] . "</b> " . $showcl . "</p>";

		# Figure out first result to be shown so we can use an offset in
		# the query to only get the results we want
		$sp = ($startpage -1) * 10;

		# Run the query (note use of LIMIT offset, count)
		$sql = "SELECT SHELTER.*, ANIMAL.* FROM ANIMAL INNER JOIN SHELTER ON ANIMAL.SHELTERID = SHELTER.ID";
		if ($where != "") $sql = $sql . " WHERE " . $where;
		$sql = $sql . " LIMIT " . ($sp) . ", 10";
		$result = runQuery($sql);
		$num = mysql_numrows($result);

		# If we have no results, output and finish.
		if ($num == 0) {
			return "<p>Sorry, no results were found.</p>";
		}

		# Work out the total results so we can make a navbar of available pages
		$resultpages = runQuery("SELECT COUNT(*) AS TOTALRESULTS FROM ANIMAL INNER JOIN SHELTER ON ANIMAL.SHELTERID = SHELTER.ID" . ($where != "" ? " WHERE " . $where : ""));
		$totalresults = mysql_result($resultpages, 0, "TOTALRESULTS");
	
		# Make the navbar
		$nopages = floor($totalresults / 10) + 1;
		$nav = "";
		for ($i=1; $i <= $nopages; $i++) {
			# If this is the page we're on, don't show a link
			if ($i == $startpage)
				$nav = $nav . $i . " ";
			else
				$nav = $nav . "<a href='search.php?" . $_SERVER['QUERY_STRING'] . "&page=" . $i . "'>" . $i . "</a> ";		
		}

		# Add next and previous links to the navbar where appropriate
		if ($startpage > 1)
			$nav = $nav . "<a href='search.php?" . $_SERVER['QUERY_STRING'] . "&page=" . ($startpage-1) . "'>" . $i18n['Previous'] . "</a> ";
		else
			$nav = $nav . $i18n['Previous'] . " ";
		if ($startpage < $nopages)
			$nav = $nav . "<a href='search.php?" . $_SERVER['QUERY_STRING'] . "&page=" . ($startpage+1) . "'>" . $i18n['Next'] . "</a> ";
		else
			$nav = $nav . $i18n['Next'];


		# Figure out last result shown
		$ep = ($sp + $num);
	
		# Create nav HTML
		$html = $html . "<p style='background-color: #c4f7ff; font-weight: bold;'>";
		$html = $html . sprintf($i18n['Results_jump_to_page'], $sp + 1, $ep, $totalresults, $nav);
		$html = $html . "</p>";

		# Outer table to hold inner table of results on left and advertising on right
		$html = $html . "<table width='100%'><tr><td>";

		# Inner table
		$html = $html . "<table>";

		for ($i = 0; $i < $num; $i++) {
			
			# Image column
			$html = $html . "<tr><td><a href='animal.php?id=" . mysql_result($result, $i, "ANIMAL.ID") . "'><img src='" . getThumbnailImage(mysql_result($result, $i, "ANIMAL.SHELTERID"), mysql_result($result, $i, "ANIMAL.IMAGEPATH")) . "' width=100 height=75 /></a></td>";
			# Name, ( Breed Species ) -  Render images of flags
			# First 100 chars of description
			# [ Shelter name/link ], [ If Breed or Species not set, Similar animals - 
			# repeats search with this animals breed/species]
			$html = $html . "<td><a href='animal.php?id=" . mysql_result($result, $i, "ANIMAL.ID") . "'>";
			$html = $html . mysql_result($result, $i, "ANIMAL.NAME") . "</a> (" . mysql_result($result, $i, "ANIMAL.BREED") . " " . mysql_result($result, $i, "ANIMAL.SPECIES") . ")";
			$html = $html . " <font size='2'>" . renderFlags(mysql_result($result, $i, "ANIMAL.FLAGS")) . "<br />";

			# Strip any html tags and line breaks
			$desc = mysql_result($result, $i, "ANIMAL.DESCRIPTION");
			$desc = str_replace("<br>", " ", $desc);
			$desc = str_replace("<br />", " ", $desc);
			# Convert _s/_t back
			$desc = str_replace("_s", "'s", $desc);
			$desc = str_replace("_t", "'t", $desc);
			
			$html = $html . substr($desc, 0, 100) . "...<br />";
			$html = $html . "<a href='shelter.php?id=" . mysql_result($result, $i, "SHELTER.ID") . "'>" . mysql_result($result, $i, "SHELTER.NAME") . "</a> ";
			
			# Similar animals search link
			$html = $html . "<a href='search.php?" . $_SERVER['QUERY_STRING'] . "&breed=" . mysql_result($result, $i, "ANIMAL.BREED") . "&species=" . mysql_result($result, $i, "ANIMAL.SPECIES") . "&page=1'>" . $i18n['Similar_animals'] . "</a>";

			# Finish entry
			$html = $html . "</font></td></tr>";
		}	

		$html = $html . "</tr></table>";

		# ========================================

		# Advertising
		$html = $html . "</td><td>";

		# My Google Adsense
		$html = $html . $advertising;

		$html = $html . "</td></tr></table>";
	
		$html = $html . "<p style='background-color: #c4f7ff; font-weight: bold;'>";
		$html = $html . sprintf($i18n['Results_jump_to_page'], $sp + 1, $ep, $totalresults, $nav);
		$html = $html . "</p>";
		return $html;
	}

	# Returns the HTML for laying out an animal's info
	# from the ID given.
	function showAnimal($id) {
		
		global $i18n;
		global $advertising;
		
		# Sanitise the ID by removing any apostrophes or semi-colons
		# TODO:
		
		$sql = "SELECT ANIMAL.*, SHELTER.* FROM ANIMAL INNER JOIN SHELTER ON ANIMAL.SHELTERID=SHELTER.ID WHERE ANIMAL.ID=" . $id;
		$result = runQuery($sql) or die($i18n['Invalid_animal_id']);
		$num = mysql_numrows($result);

		if ($num == 0) {
			return "<p>" . $i18n['Animal_does_not_exist'] . "</p>";
		}
		
		# Make a link to the shelter holding the animal
		$shelterlink = "<a href='shelter.php?id=" . mysql_result($result, 0, "SHELTER.ID") . "'>" . mysql_result($result, 0, "SHELTER.NAME") . "</a>";

		# Layout the HTML - two column table with the image on the left and 
		# animal info on the right
		$html = "";
		$html = $html . "<table width=100%><tr><td valign=top>";
		$html = $html . "<img src='" . getAnimalImage(mysql_result($result, 0, "SHELTER.ID"), mysql_result($result, 0, "ANIMAL.IMAGEPATH")) ;
		$html = $html . "' /></td><td valign=top>";

		$html = $html . "<b>" . sprintf($i18n['Animal_located_at'], mysql_result($result, 0, "ANIMAL.NAME"), showSize(mysql_result($result, 0, "ANIMAL.ANIMALSIZE")), showAge(mysql_result($result, 0, "ANIMAL.AGE")), mysql_result($result, 0, "ANIMAL.BREED"), mysql_result($result, 0, "ANIMAL.SPECIES"), $shelterlink) . "</b><br /><br />";
		$html = $html . renderFlags(mysql_result($result, 0, "ANIMAL.FLAGS")) . "<br /><br />";

		$desc = mysql_result($result, 0, "ANIMAL.DESCRIPTION");
		# Convert _s back
		$desc = str_replace("_s", "'s", $desc);
		$desc = str_replace("_t", "'t", $desc);

		$html = $html . $desc;
		$html = $html . "<br />&nbsp;<br />&nbsp;<br />";
		$html = $html . showShelter(mysql_result($result, 0, "SHELTER.ID"));

		$html = $html . "</td><td width=20%>$advertising</td></tr></table>";

		
		return $html;
	}

	# Returns the path to an animal's image if it exists, or to
	# the local nopic.png if it doesn't
	function getAnimalImage($shelterid, $imagepath) {

		global $homes;
		global $shelterpicsalias;

		$theimage = $homes . "/" . $shelterid . "/" . $imagepath;

		# Test file exists
		if (file_exists($theimage)) {
			# It does
			return $shelterpicsalias . "/" . $shelterid . "/" . $imagepath;
		}
		else {
			return "images/nopic.png";
		}
	}
	
	# Returns the path to an animal's thumb image if it exists, or to
	# the local nopic.thm.png if it doesn't
	function getThumbnailImage($shelterid, $imagepath) {

		global $homes;
		global $shelterpicsalias;
		
		$theimage = $homes . "/" . $shelterid . "/" . $imagepath . ".thm.jpg";
		
		# Test file exists
		if (file_exists($theimage)) {
			# It does
			return $shelterpicsalias . "/" . $shelterid . "/" . $imagepath . ".thm.jpg";
		}
		else {
			return "images/nopic.thm.png";
		}
	}

	# Returns the HTML for laying out a shelter's info
	# from the ID given.
	function showShelter($id) {
		
		global $i18n;

		# Sanitise the ID by removing any apostrophes or semi-colons
		# TODO:
		
		$sql = "SELECT SHELTER.* FROM SHELTER WHERE ID='" . $id . "'";
		$result = runQuery($sql) or die($i18n['Invalid_shelter_id']);
		$num = mysql_numrows($result);

		if ($num == 0) {
			return "<p>" . $i18n['Shelter_does_not_exist'] . "</p>";
		}
		
		# Layout the HTML - two column table with label on the left and 
		# info on the right
		$html = "";
		$html = $html . "<table width=100%>";
		$html = $html . "<tr><td><b>" . $i18n['Name'] . "</b></td><td>";
		$html = $html . mysql_result($result, 0, "NAME") . "</td></tr>";
		$html = $html . "<tr><td><b>" . $i18n['Address'] . "</b></td><td>";
		$html = $html . mysql_result($result, 0, "ADDRESS") . "</td></tr>";
		$html = $html . "<tr><td><b>" . $i18n['Phone'] . "</b></td><td>";
		$html = $html . mysql_result($result, 0, "PHONE") . "</td></tr>";
		$html = $html . "<tr><td><b>" . $i18n['Email'] . "</b></td><td>";
		$html = $html . "<a href='mailto:" . mysql_result($result, 0, "EMAIL") . "'>";
		$html = $html . mysql_result($result, 0, "EMAIL") . "</a></td></tr>";
		$html = $html . "<tr><td><b>" . $i18n['Website'] . "</b></td><td>";
		$html = $html . "<a href='" . mysql_result($result, 0, "WEBSITE") . "'>";
		$html = $html . mysql_result($result, 0, "WEBSITE") . "</a></td></tr>";

		$html = $html . "</table>";
		
		return $html;
	}

	function showAge($age) {

		global $i18n;
	
		if ($age == 0) return $i18n['Baby'];
		if ($age == 1) return $i18n['Young'];
		if ($age == 2) return $i18n['Adult'];
		if ($age == 3) return $i18n['Senior'];
	}

	function showGender($gender) {
	
		global $i18n;

		if ($gender == 0) return $i18n['Male'];
		if ($gender == 1) return $i18n['Female'];
	}

	function showSize($size) {

		global $i18n;

		if ($size == 3) return $i18n['Small'];
		if ($size == 2) return $i18n['Medium'];
		if ($size == 1) return $i18n['Large'];
		if ($size == 0) return $i18n['Very Large'];
	}


	# Given the flag field, outputs HTML to display them.
	# C = Good with cats
	# D = Good with dogs
	# H = Housetrained
	# K = Good with kids
	# V = Vaccinated
	# N = Neutered
	function renderFlags($flags) {
		global $i18n;

		$html = "";
		if (strpos($flags, "C") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Good_with_cats'] . "' src='images/cat.png' />";
		}
		if (strpos($flags, "D") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Good_with_dogs'] . "' src='images/dog.png' />";
		}
		if (strpos($flags, "K") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Good_with_kids'] . "' src='images/kids.png' />";
		}
		if (strpos($flags, "c") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Bad_with_cats'] . "' src='images/cat_no.png' />";
		}
		if (strpos($flags, "d") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Bad_with_dogs'] . "' src='images/dog_no.png' />";
		}
		if (strpos($flags, "k") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Bad_with_kids'] . "' src='images/kids_no.png' />";
		}
		if (strpos($flags, "H") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Housetrained'] . "' src='images/housetrained.png' />";
		}
		if (strpos($flags, "V") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Vaccinated'] . "' src='images/vaccinated.png' />";
		}
		if (strpos($flags, "N") !== FALSE) {
			$html = $html . "<img title='" . $i18n['Neutered'] . "' src='images/neutered.png' />";
		}
		return $html;
	}

	# Returns the total number of animals in the database
	function getTotalAnimals() {
		$result = runQuery("SELECT COUNT(*) AS TOT FROM ANIMAL");
		return mysql_result($result, 0, "TOT");
	}

	# Checks whether a user can login. Returns either the
	# username for success or an empty string for fail.
	function login($user, $pass) {
	
		# Check against the database - redirect on fail
		$result = runQuery("SELECT * FROM SHELTER WHERE ID LIKE '$user' AND PASSWORD='$pass'");
		
		# Redirect if no rows are returned
		$num = mysql_numrows($result);
		if ($num == 0) return "";

		return mysql_result($result, 0, "ID");
		
	}

	# Outputs a list of animals for a shelter with maintainence links to
	# edit and delete.
	function showAnimalMaintain($shelterid) {

		global $i18n;
		global $shelterpicsalias;

		$result = runQuery("SELECT * FROM ANIMAL WHERE SHELTERID = '$shelterid' ORDER BY NAME");
		$num = mysql_numrows($result);
		$html = "<table width=100% border=1 cellspacing=0 cellpadding=1><tr>";

		$col = 0;
		for ($i = 0; $i < $num; $i++) {
			$html = $html . "";
			$id = mysql_result($result, $i, "ID");
			$html = $html . "<td><a href='editanimal.php?id=$id'><img title='" . $i18n['Edit'] . "' border=0 src='" . getThumbnailImage($shelterid, mysql_result($result, $i, "IMAGEPATH")) . "' /><br />";
			$html = $html . mysql_result($result, $i, "NAME") . "</a> <a href='deleteanimal.php?id=$id'><img border=0 src='images/delete.png' title='" . $i18n['Delete'] . "' /></a>";
			$html = $html . "</td>";
			$col++;
			
			if ($col == 5) {
				$html = $html . "</tr><tr>";
				$col = 0;
			}
			
		}
		$html = $html . "</tr></table>";


		return $html;

	}

	# Delete an animal from its ID
	function deleteAnimal($id) {
		executeQuery("DELETE FROM ANIMAL WHERE ID=$id");
	}

	# Returns an associative array of animal info from the record
	# name, description, flags, sex, age, size, imagepath, shelterid, breed, species
	function getAnimal($id) {
		$result = runQuery("SELECT * FROM ANIMAL WHERE ID=$id");
		$num = mysql_numrows($result);
		if ($num == 0) {
			$animal['name'] = "";
			return $animal;
		}
		$animal['name'] = mysql_result($result, 0, "NAME");
		$animal['description'] = mysql_result($result, 0, "DESCRIPTION");
		$animal['flags'] = mysql_result($result, 0, "FLAGS");
		$animal['sex'] = mysql_result($result, 0, "SEX");
		$animal['age'] = mysql_result($result, 0, "AGE");
		$animal['size'] = mysql_result($result, 0, "ANIMALSIZE");
		$animal['imagepath'] = mysql_result($result, 0, "IMAGEPATH");
		$animal['shelterid'] = mysql_result($result, 0, "SHELTERID");
		$animal['breed'] = mysql_result($result, 0, "BREED");
		$animal['species'] = mysql_result($result, 0, "SPECIES");

		return $animal;
	}

	# Adds an animal to the database
	function addAnimal($name, $description, $species, $breed, $age, $gender, $size, $flags, $shelterid, $haspic, $picname) {
		$sql = "INSERT INTO ANIMAL (SHELTERID, NAME, DESCRIPTION, SPECIES, BREED, AGE, SEX, ANIMALSIZE, FLAGS, IMAGEPATH) VALUES ('$shelterid', '$name', '$description', '$species', '$breed', $age, $gender, $size, '$flags', '$picname')";
		executeQuery($sql);
	}

	# Updates animal details in the database
	function updateAnimal($id, $name, $description, $flags) {
		$sql = "UPDATE ANIMAL SET NAME='$name', DESCRIPTION='$description', FLAGS='$flags' WHERE ID=$id";
		executeQuery($sql);
	}
?>
